loci.formats.codec

## Class CodecOptions

- java.lang.Object
- - loci.formats.codec.CodecOptions

- Direct Known Subclasses:
    HuffmanCodecOptions, JPEG2000CodecOptions, MJPBCodecOptions, NikonCodecOptions

      public class CodecOptions
      extends java.lang.Object

  Options for compressing and decompressing data.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int` | `bitsPerSample` Number of bits per channel.
    `int` | `channels` Number of channels.
    `java.awt.image.ColorModel` | `colorModel` Color model to use when constructing an image (WRITE).
    `boolean` | `disableChromaSubsampling` Whether or not to use chroma subsampling.
    `int` | `height` Height, in pixels, of the image.
    `boolean` | `interleaved` Indicates whether or not channels are interleaved.
    `boolean` | `littleEndian` Indicates endianness of pixel data.
    `boolean` | `lossless` Used with codecs allowing lossy and lossless compression.
    `int` | `maxBytes` If compressing, this is the maximum number of raw bytes to compress.
    `byte[]` | `previousImage` Pixels for preceding image (READ/WRITE).
    `double` | `quality` Compression quality level as it would be provided to: `ImageWriteParam.compressionQuality` (WRITE).
    `boolean` | `signed` Indicates whether or not the pixel data is signed.
    `int` | `tileGridXOffset` Horizontal offset of the tile grid as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).
    `int` | `tileGridYOffset` Vertical offset of the tile grid as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).
    `int` | `tileHeight` Tile height as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).
    `int` | `tileWidth` Tile width as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).
    `int` | `width` Width, in pixels, of the image.
    `boolean` | `ycbcr` Whether or not the decompressed data will be stored as YCbCr.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CodecOptions()` Construct a new CodecOptions.
    `CodecOptions(CodecOptions options)` Construct a new CodecOptions using the given CodecOptions.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static CodecOptions` | `getDefaultOptions()` Return CodecOptions with reasonable default values.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### width

          public int width

      Width, in pixels, of the image. (READ/WRITE)

    - #### height

          public int height

      Height, in pixels, of the image. (READ/WRITE)

    - #### channels

          public int channels

      Number of channels. (READ/WRITE)

    - #### bitsPerSample

          public int bitsPerSample

      Number of bits per channel. (READ/WRITE)

    - #### littleEndian

          public boolean littleEndian

      Indicates endianness of pixel data. (READ/WRITE)

    - #### interleaved

          public boolean interleaved

      Indicates whether or not channels are interleaved. (READ/WRITE)

    - #### signed

          public boolean signed

      Indicates whether or not the pixel data is signed. (READ/WRITE)

    - #### tileWidth

          public int tileWidth

      Tile width as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).

    - #### tileHeight

          public int tileHeight

      Tile height as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).

    - #### tileGridXOffset

          public int tileGridXOffset

      Horizontal offset of the tile grid as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).

    - #### tileGridYOffset

          public int tileGridYOffset

      Vertical offset of the tile grid as it would be provided to: `ImageWriteParam.setTiling(int, int, int, int)` (WRITE).

    - #### maxBytes

          public int maxBytes

      If compressing, this is the maximum number of raw bytes to compress. If decompressing, this is the maximum number of raw bytes to return. (READ/WRITE).

    - #### previousImage

          public byte[] previousImage

      Pixels for preceding image (READ/WRITE).

    - #### lossless

          public boolean lossless

      Used with codecs allowing lossy and lossless compression. Default is set to true (WRITE).

    - #### colorModel

          public java.awt.image.ColorModel colorModel

      Color model to use when constructing an image (WRITE).

    - #### quality

          public double quality

      Compression quality level as it would be provided to: `ImageWriteParam.compressionQuality` (WRITE).

    - #### ycbcr

          public boolean ycbcr

      Whether or not the decompressed data will be stored as YCbCr.

    - #### disableChromaSubsampling

          public boolean disableChromaSubsampling

      Whether or not to use chroma subsampling. Only used when creating an image (WRITE). Default is false (use chroma subsampling).

  - ### Constructor Detail

    - #### CodecOptions

          public CodecOptions()

      Construct a new CodecOptions.

    - #### CodecOptions

          public CodecOptions(CodecOptions options)

      Construct a new CodecOptions using the given CodecOptions.

  - ### Method Detail

    - #### getDefaultOptions

          public static CodecOptions getDefaultOptions()

      Return CodecOptions with reasonable default values.

Copyright © 2026 Open Microscopy Environment